program ICHelloCruelWorld;
	(* ICHelloCruelWorld *)
	(* The simplest IC aware program. It simply outputs *)
	(* Real Name preference, which is assumed to contain *)
	(* the text "Hello Cruel World!" *)

	uses
		ICTypes, ICAPI, ICKeys;	(* standard IC units *)

	var
		instance: ICInstance;
						(* opaque reference to IC session *)
		str: Str255;
						(* buffer to read real name into *)
		str_size: longint;
						(* size of above buffer *)
		junk: ICError;
						(* place to throw away error results *)
		junk_attr: ICAttr;
					(* place to throw away attributes *)
begin
	(* start IC *)
	if ICStart(instance, '????') = noErr then begin
		(* specify a database, in this case the default one *)
		if ICFindConfigFile(instance, 0, nil) = noErr then begin
			(* read the real name preferences *)
			str_size := sizeof(str);
			if ICGetPref(instance, kICRealName, junk_attr,
							@str, str_size) = noErr then begin
				writeln(str);
			end; (* if *)
			(* shut down IC *)
			junk := ICStop(instance);
		end; (* if *)
	end; (* if *)
end. (* ICHelloCruelWorld *)
