unit ICComponentSelectors;

(* This unit holds the selectors for the IC component.  I've moved this into a unit so *)
(* that the override components can access this information without having to *)
(* duplicate it. *)

interface

	const
		kICCStart = $00;
		kICCStop = $01;
		kICCFindConfigFile = $02;
		kICCSpecifyConfigFile = $03;
		kICCGetSeed = $04;
		kICCBegin = $05;
		kICCGetPref = $06;
		kICCSetPref = $07;
		kICCCountPref = $08;
		kICCGetIndPref = $09;
		kICCEnd = $0A;
		kICCDefaultFile = $0B;
		kICCDeletePref = $0C;
		kICCGetPerm = $0D;
		kICCFindUserConfigFile = $0E;
		kICCEditPreferences = $0F;
		kICCParseURL = $10;
		kICCLaunchURL = $11;
		kICCCountMapEntries = $12;
		kICCGetIndMapEntry = $13;
		kICCGetMapEntry = $14;
		kICCSetMapEntry = $15;
		kICCDeleteMapEntry = $16;
		kICCAddMapEntry = $17;
		kICCMapFilename = $18;
		kICCMapTypeCreator = $19;
		kICCGetPrefHandle = $1A;
		kICCSetPrefHandle = $1B;
		kICCMapEntriesFilename = $1C;
		kICCMapEntriesTypeCreator = $1D;
		kICC_first_select = kICCStart;
		kICC_last_select = kICCMapEntriesTypeCreator;

	function SelectorToStr (what: integer): Str32;
(* This routine is great for debugging because you don't have to *)
(* what all of those random selectors are. *)

implementation

	uses
		Components;

	function SelectorToStr (what: integer): Str32;
	begin
		case what of
			(* Component Manager stuff *)
			kComponentVersionSelect: 
				SelectorToStr := 'kComponentVersionSelect';
			kComponentCanDoSelect: 
				SelectorToStr := 'kComponentCanDoSelect';
			kComponentOpenSelect: 
				SelectorToStr := 'kComponentOpenSelect';
			kComponentCloseSelect: 
				SelectorToStr := 'kComponentCloseSelect';
			kComponentTargetSelect: 
				SelectorToStr := 'kComponentTargetSelect';
			kComponentRegisterSelect: 
				SelectorToStr := 'kComponentRegisterSelect';
			kComponentUnregisterSelect: 
				SelectorToStr := 'kComponentUnregisterSelect';
			(* this component type stuff *)
			kICCStart: 
				SelectorToStr := 'kICCStart';
			kICCStop: 
				SelectorToStr := 'kICCStop';
			kICCFindConfigFile: 
				SelectorToStr := 'kICCFindConfigFile';
			kICCSpecifyConfigFile: 
				SelectorToStr := 'kICCSpecifyConfigFile';
			kICCGetSeed: 
				SelectorToStr := 'kICCGetSeed';
			kICCBegin: 
				SelectorToStr := 'kICCBegin';
			kICCGetPref: 
				SelectorToStr := 'kICCGetPref';
			kICCSetPref: 
				SelectorToStr := 'kICCSetPref';
			kICCCountPref: 
				SelectorToStr := 'kICCCountPref';
			kICCGetIndPref: 
				SelectorToStr := 'kICCGetIndPref';
			kICCEnd: 
				SelectorToStr := 'kkICCEndICCGetPref';
			kICCDefaultFile: 
				SelectorToStr := 'kICCDefaultFile';
			kICCDeletePref: 
				SelectorToStr := 'kICCDeletePref';
			kICCGetPerm: 
				SelectorToStr := 'kICCGetPerm';
			kICCFindUserConfigFile: 
				SelectorToStr := 'kICCFindUserConfigFile';
			kICCEditPreferences: 
				SelectorToStr := 'kICCEditPreferences';
			kICCParseURL: 
				SelectorToStr := 'kICCParseURL';
			kICCLaunchURL: 
				SelectorToStr := 'kICCLaunchURL';
			kICCCountMapEntries: 
				SelectorToStr := 'kICCCountMapEntries';
			kICCGetIndMapEntry: 
				SelectorToStr := 'kICCGetIndMapEntry';
			kICCGetMapEntry: 
				SelectorToStr := 'kICCGetMapEntry';
			kICCSetMapEntry: 
				SelectorToStr := 'kICCSetMapEntry';
			kICCDeleteMapEntry: 
				SelectorToStr := 'kICCDeleteMapEntry';
			kICCAddMapEntry: 
				SelectorToStr := 'kICCAddMapEntry';
			kICCMapFilename: 
				SelectorToStr := 'kICCMapFilename';
			kICCMapTypeCreator: 
				SelectorToStr := 'kICCMapTypeCreator';
			kICCGetPrefHandle: 
				SelectorToStr := 'kICCGetPrefHandle';
			kICCSetPrefHandle: 
				SelectorToStr := 'kICCSetPrefHandle';
			kICCMapEntriesFilename: 
				SelectorToStr := 'kICCMapEntriesFilename';
			kICCMapEntriesTypeCreator: 
				SelectorToStr := 'kICCMapEntriesTypeCreator';
			otherwise
				SelectorToStr := 'other';
		end; (* case *)
	end; (* SelectorToStr *)

end. (* ICComponentSelectors *)